program generatepkt;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  classes;

const	crc32inv=	$EDB88320;//	;EtherCRC32 0x04C11DB7 bit mirrored
var crc32:longword;
    infobitc:integer;

var csl:Tstringlist;
    group:string;

    infobuffer:array [0..24] of byte; //200 extra config info bit
{
    config info:
    64 bit channel identifier, 136 bit tilbag





}

function getinfobit:integer;
begin
  if (infobitc shr 3)>=sizeof(infobuffer) then begin
    result:=0;
  end;
  result:=(infobuffer[infobitc shr 3] shr (infobitc and 7)) and 1;
  inc(infobitc);
end;


function cfg(s,def:string):integer;
var r:string;
begin
  r:=GetenvironmentVariable(s);
  if r<>'' then begin
    writeln(ErrOutput,'using from environment: '+s+'='+r);
    result:=strtoint(r);
    exit;
  end;
  r:=GetenvironmentVariable(group+'.'+s);
  if r<>'' then begin
    writeln(ErrOutput,'using from environment: '+group+'.'+s+'='+r);
    result:=strtoint(r);
    exit;
  end;

  s:=group+'.'+s;
  if csl.values[s]='' then begin
    csl.values[s]:=def;
  end;
  result:=strtoint(csl.values[s]);
end;

procedure crcbit(n:byte);
var bit:integer;
begin
  if ((crc32 xor n) and 1)<>0 then
    crc32:=(crc32 shr 1) xor crc32inv
  else
    crc32:=	(crc32 shr 1);
end;

procedure SendByte(n:byte);
var bit:integer;
begin
  for bit:=0 to 7 do
	if ((n shr bit) and 1)<>0 then begin
    writeln(' out ETHPort,RegEther1');
    writeln(' out ETHPort,RegEther0');
	  crcbit(1);
	end else begin
    writeln(' out ETHPort,RegEther0');
    writeln(' out ETHPort,RegEther1');
	  crcbit(0);
	end;
end;

procedure SendHighBit(s0,s1:string);
var bit,w:longword;
begin
	writeln(';payload bit');
  for bit:=0 to 6 do
	if getinfobit<>0 then begin
    writeln(' out ETHPort,RegEther1');
    writeln(' out ETHPort,RegEther0');
	  crcbit(1);
	end else begin
    writeln(' out ETHPort,RegEther0');
    writeln(' out ETHPort,RegEther1');
	  crcbit(0);
	end;
	writeln(' out ETHPort,',s1);
	writeln(' out ETHPort,',s0);
	crcbit(0);

	writeln(';crc compensation starts here');
  w:=crc32inv;
  for bit:=0 to 31 do
    if ((w shr bit)and 1)<>0 then begin
      writeln(' out ETHPort,',s1);
      writeln(' out ETHPort,',s0);
	    crcbit(0);
    end else begin
      if getinfobit<>0 then begin
        writeln(' out ETHPort,RegEther1');
        writeln(' out ETHPort,RegEther0');
	      crcbit(1);
      end else begin
        writeln(' out ETHPort,RegEther0');
        writeln(' out ETHPort,RegEther1');
	      crcbit(0);
      end;
    end;
end;

const MACSourceAddr5 = $00;
const MACSourceAddr4 = $09;
const MACSourceAddr3 = $C1;
const MACSourceAddr2 = $E9;
const MACSourceAddr1 = $53;
const MACSourceAddr0 = $12;


const MACDestAddr5 = $FF;
const MACDestAddr4 = $FF;
const MACDestAddr3 = $FF;
const MACDestAddr2 = $FF;
const MACDestAddr1 = $FF;
const MACDestAddr0 = $FF;

const EthPacketType=$0800;

  IPSourceAddr3=129;
  IPSourceAddr2=129;
  IPSourceAddr1=129;
  IPSourceAddr0=51;

  IPDestAddr3=255;
  IPDestAddr2=255;
  IPDestAddr1=255;
  IPDestAddr0=255;

procedure multiframe(mgroup:string);
var ipchecksum,ccrc32:longword;
  i:integer;

  MACSourceAddr5,
  MACSourceAddr4,
  MACSourceAddr3,
  MACSourceAddr2,
  MACSourceAddr1,
  MACSourceAddr0,

  MACDestAddr5,
  MACDestAddr4,
  MACDestAddr3,
  MACDestAddr2,
  MACDestAddr1,
  MACDestAddr0,

  UDPDatalength,
  IPVersionLength,
  IPTypeOfService,
  IPLength,
  IPDatagramID,
  IPFlags,
  IPOffset,
  IPTimeToLive,
  IPUsedProtocol,
  UDPSourcePort,
  UDPDestPort,
  UDPMessageLength,
  UDPChecksum:integer;

  IPSourceAddr3,
  IPSourceAddr2,
  IPSourceAddr1,
  IPSourceAddr0,

  IPDestAddr3,
  IPDestAddr2,
  IPDestAddr1,
  IPDestAddr0:integer;
begin
 fillchar(infobuffer,sizeof(infobuffer),0);

 group:='device';
 MACSourceAddr5 := cfg('MACSourceAddr5','$00');
 MACSourceAddr4 := cfg('MACSourceAddr4','$09');
 MACSourceAddr3 := cfg('MACSourceAddr3','$C1');
 MACSourceAddr2 := cfg('MACSourceAddr2','$FF');
 MACSourceAddr1 := cfg('MACSourceAddr1','$B9');
 MACSourceAddr0 := cfg('MACSourceAddr0','$5E');
 group:=mgroup;

 IPSourceAddr3:=cfg('IPSourceAddr3','172');
 IPSourceAddr2:=cfg('IPSourceAddr2','31');
 IPSourceAddr1:=cfg('IPSourceAddr1','219');
 IPSourceAddr0:=cfg('IPSourceAddr0','100');

 IPDestAddr3:=cfg('IPDestAddr3','255');
 IPDestAddr2:=cfg('IPDestAddr2','255');
 IPDestAddr1:=cfg('IPDestAddr1','255');
 IPDestAddr0:=cfg('IPDestAddr0','255');

 if (IPDestAddr3<=239) and (IPDestAddr3>=224) then begin
   MACDestAddr5:=$01; //calculate multicast address
   MACDestAddr4:=$00;
   MACDestAddr3:=$5E;
   MACDestAddr2:=IPDestAddr2 and 127;
   MACDestAddr1:=IPDestAddr1;
   MACDestAddr0:=IPDestAddr0;
 end else begin
   MACDestAddr5 := cfg('MACDestAddr5','$FF');
   MACDestAddr4 := cfg('MACDestAddr4','$FF');
   MACDestAddr3 := cfg('MACDestAddr3','$FF');
   MACDestAddr2 := cfg('MACDestAddr2','$FF');
   MACDestAddr1 := cfg('MACDestAddr1','$FF');
   MACDestAddr0 := cfg('MACDestAddr0','$FF');
 end;

 UDPDatalength:=	40;
 IPVersionLength:=	$45;
 IPTypeOfService := cfg('ipTOS','$00');
 IPLength:=20+8+UDPDataLength;
 IPDatagramID := cfg('ipDatagramID','$0000');
 IPFlags:=		cfg('ipFlags','$00');
 IPOffset:=		$00;
 IPTimeToLive:=	cfg('ipTTL','1');
 IPUsedProtocol:=	$11;
 UDPSourcePort:=	cfg('ipSourcePort','6668');
 UDPDestPort:=	cfg('ipDestinationPort','70');
 UDPMessageLength:= 8+UDPDatalength;
 UDPChecksum:=$0000;

  writeln(' ;preamble');
  SendByte($55);
  SendByte($55);
  SendByte($55);
  SendByte($55);
  SendByte($55);
  SendByte($55);
  SendByte($55);
  SendByte($D5);
  crc32:=$FFFFFFFF;
  SendByte (MACDestAddr5);
  SendByte (MACDestAddr4);
  SendByte (MACDestAddr3);
  SendByte (MACDestAddr2);
  SendByte (MACDestAddr1);
  SendByte (MACDestAddr0);
  writeln(' ;src');
  SendByte(MACSourceAddr5);
  SendByte(MACSourceAddr4);
  SendByte(MACSourceAddr3);
  SendByte(MACSourceAddr2);
  SendByte(MACSourceAddr1);
  SendByte(MACSourceAddr0);

  i:=(cfg('802.1QPriority','0') shl 13) + cfg('802.1QVlan','0'); //high priority
  if i<>0 then begin
    writeln(' ;vlanheader '+inttostr(i));
    SendByte ($81); //802.1Q
    SendByte ($00);
    SendByte (i shr 8);
    SendByte (i and 255);
  end;

  writeln(' ;ethertype');
  SendByte (EthPacketType shr 8);
  SendByte (EthPacketType and $FF);

  writeln(' ;ipheader - calculation borrowed from Igor');
  IPchecksum:=	0;
  IPchecksum:=	IPchecksum + (IPVersionLength shl 8) + IPTypeOfService;
  IPchecksum:=	IPchecksum + (IPTypeOfService shl 8) + IPLength;
  IPchecksum:=	IPchecksum + IPDatagramID;
  IPchecksum:=	IPchecksum + (IPFlags         shl 8) + IPOffset;
  IPchecksum:=	IPchecksum + (IPTimeToLive    shl 8) + IPUsedProtocol;
  IPchecksum:=	IPchecksum + (IPSourceAddr3   shl 8) + IPSourceAddr2;
  IPchecksum:=	IPchecksum + (IPSourceAddr1   shl 8) + IPSourceAddr0;
  IPchecksum:=	IPchecksum + (IPDestAddr3     shl 8) + IPDestAddr2;
  IPchecksum:=	IPchecksum + (IPDestAddr1     shl 8) + IPDestAddr0;
  IPchecksum:=	(not (IPchecksum + (IPchecksum shr 16)));

  SendByte(IPVersionLength);
  SendByte(IPTypeOfService);
  SendByte(IPLength shr 8);
  SendByte(IPLength and 255);
  SendByte(IPDatagramID shr 8);
  SendByte(IPDatagramID and 255);
  SendByte(IPFlags);
  SendByte(IPOffset);
  SendByte(IPTimeToLive);
  SendByte(IPUsedProtocol);
  SendByte(IPChecksum shr 8);
  SendByte(IPChecksum and 255);
  SendByte(IPSourceAddr3);
  SendByte(IPSourceAddr2);
  SendByte(IPSourceAddr1);
  SendByte(IPSourceAddr0);
  SendByte(IPDestAddr3);
  SendByte(IPDestAddr2);
  SendByte(IPDestAddr1);
  SendByte(IPDestAddr0);

  writeln(' ;udpheader');
  SendByte(UDPSourcePort shr 8);
  SendByte(UDPSourcePort and 255);
  SendByte(UDPDestPort shr 8);
  SendByte(UDPDestPort and 255);
  SendByte(UDPMessageLength shr 8);
  SendByte(UDPMessageLength and 255);
  SendByte(UDPChecksum shr 8);
  SendByte(UDPChecksum and 255);
  //for i:=1 to 5*8 do docrc(0);
  writeln(' ;data');
  infobitc:=0;
  SendHighBit('RegEther0bit0', 'RegEther1bit0');
  SendHighBit('RegEther0bit1', 'RegEther1bit1');
  SendHighBit('RegEther0bit2', 'RegEther1bit2');
  SendHighBit('RegEther0bit3', 'RegEther1bit3');
  SendHighBit('RegEther0bit4', 'RegEther1bit4');
  SendHighBit('RegEther0bit5', 'RegEther1bit5');
  SendHighBit('RegEther0bit6', 'RegEther1bit6');
  SendHighBit('RegEther0bit7', 'RegEther1bit7');
  writeln(' ;final crc - xinfobits=',infobitc);
  ccrc32:=not crc32;
  SendByte	((ccrc32)and 255)	; //skal sendes inverteret
  SendByte	((ccrc32)shr 8)	;
  SendByte	((ccrc32)shr 16)	;
  SendByte	((ccrc32)shr 24)	;
end;


var i:integer;

begin
  csl:=Tstringlist.create;
  csl.loadfromfile('gen.cf');
  multiframe(paramstr(1));
  csl.SaveTofile('gen.cf');
  writeln;
end.
