

#include <avr/io.h>
#include "board.h"

	.section	.text


.global ether_sync


.global sendpps_burststart
.global sendpps_burstend
.global sendpk_burststart
.global sendpk_burstend


ether_sync:
        in  r25,ETHPort
        andi r25,~((1<<TxMinusPin)|(1<<TxPlusPin))
        mov r24,r25
        ori r24,1<<TxMinusPin

        in r26,ETHDirection
        ori r26,(1<<TxMinusPin)|(1<<TxPlusPin)
        out     ETHDirection,r26

        out     ETHPort,r24
        out     ETHPort,r25
        ret



#define	RegEther0              R0
#define	RegEther1              R1
#define	RegEther0bit0		R2
#define	RegEther1bit0		R3
#define	RegEther0bit1		R4
#define	RegEther1bit1		R5
#define	RegEther0bit2		R6
#define	RegEther1bit2		R7
#define	RegEther0bit3		R8
#define	RegEther1bit3		R9
#define	RegEther0bit4		R10
#define	RegEther1bit4		R11
#define	RegEther0bit5		R12
#define	RegEther1bit5		R13
#define	RegEther0bit6		R14
#define	RegEther1bit6		R15
#define	temp0                   R16
#define	temp1			R17
#define	temp2			R18
#define	temp3			R19
#define	temp4			R20
#define	InfraBufferFull		R21
#define	RegEther0bit7		R22
#define	RegEther1bit7		R23
;R24 = data ind


.extern      PreciseTxTime

.global sendpk
.global sendpk_precise

sendpk_precise:
//        in      r18,_SFR_IO_ADDR(TCNT1L)
//        in      r19,_SFR_IO_ADDR(TCNT1H)
        lds      r18,TCNT1L
        lds      r19,TCNT1H
        lds     r20,PreciseTxTime+0
        lds     r21,PreciseTxTime+1
        sub     r20,r18
        sbc     r21,r19
        brpl    sendpk_precise ;12 ck loop
        //-1 .. -12
        ldi     r30,lo8(pm(wm1pt))
        ldi     r31,hi8(pm(wm1pt))
        sub     r30,r20
        sbc     r31,r21
wm1pt:  ijmp
        nop ;f  -1
        nop ;e
        nop ;d
        nop ;c
        nop ;b
        nop ;a
        nop ;9
        nop ;8
        nop ;7  -9
        nop ;6  -10
        nop ;5  -11
            ;4  -12
sendpk:
	push	temp0			;store used registers (can be used in main program)
	push	temp1
	push	temp2
	push	RegEther0
	push	RegEther1
	push	RegEther0bit0
	push	RegEther1bit0
	push	RegEther0bit1
	push	RegEther1bit1
	push	RegEther0bit2
	push	RegEther1bit2
	push	RegEther0bit3
	push	RegEther1bit3
	push	RegEther0bit4
	push	RegEther1bit4
	push	RegEther0bit5
	push	RegEther1bit5
	push	RegEther0bit6
	push	RegEther1bit6
	push	RegEther0bit7
	push	RegEther1bit7 ;21=42ck

        in      temp0, ETHPort                  ;load port state
        cbr     temp0, (1<<TxPlusPin)|(1<<TxMinusPin)          ;clear TX+ and TX-
	mov	temp1,temp0			;store the default state for recovering
	out     ETHPort,temp1			;back to port as default state - no voltage between TX pins

	sbr     temp0, (1<<TxMinusPin)          ;set TX- (TX+ was cleared)
        mov     RegEther0, temp0               ;and store as log0 state

        sbr     temp0, (1<<TxPlusPin)           ;set TX+
        cbr     temp0, (1<<TxMinusPin)          ;clear TX-
        mov     RegEther1, temp0               ;and store as log1 state

        mov temp2,r24
	mov	RegEther0bit0,RegEther0		;assign to UDPBit value
	mov	RegEther1bit0,RegEther1
	mov	RegEther0bit1,RegEther0		;assign to UDPBit value
	mov	RegEther1bit1,RegEther1
	mov	RegEther0bit2,RegEther0		;assign to UDPBit value
	mov	RegEther1bit2,RegEther1
	mov	RegEther0bit3,RegEther0		;assign to UDPBit value
        mov	RegEther1bit3,RegEther1
	mov	RegEther0bit4,RegEther0		;assign to UDPBit value
	mov	RegEther1bit4,RegEther1
	mov	RegEther0bit5,RegEther0		;assign to UDPBit value
	mov	RegEther1bit5,RegEther1
	mov	RegEther0bit6,RegEther0		;assign to UDPBit value
	mov	RegEther1bit6,RegEther1
	mov	RegEther0bit7,RegEther0		;assign to UDPBit value
	mov	RegEther1bit7,RegEther1
	bst	temp2,0					;store bit to T
	bld	RegEther0bit0,TxMinusPin		;and store it to given register
	bld	RegEther1bit0,TxPlusPin
	bst	temp2,1					;store bit to T
	bld	RegEther0bit1,TxMinusPin		;and store it to given register
	bld	RegEther1bit1,TxPlusPin
	bst	temp2,2					;store bit to T
	bld	RegEther0bit2,TxMinusPin		;and store it to given register
	bld	RegEther1bit2,TxPlusPin
	bst	temp2,3					;store bit to T
	bld	RegEther0bit3,TxMinusPin		;and store it to given register
	bld	RegEther1bit3,TxPlusPin
	bst	temp2,4					;store bit to T
	bld	RegEther0bit4,TxMinusPin		;and store it to given register
	bld	RegEther1bit4,TxPlusPin
	bst	temp2,5					;store bit to T
	bld	RegEther0bit5,TxMinusPin		;and store it to given register
	bld	RegEther1bit5,TxPlusPin
	bst	temp2,6					;store bit to T
	bld	RegEther0bit6,TxMinusPin		;and store it to given register
	bld	RegEther1bit6,TxPlusPin
	bst	temp2,7					;store bit to T
	bld	RegEther0bit7,TxMinusPin		;and store it to given register
	bld	RegEther1bit7,TxPlusPin
	;--------------------------------------------------------------
	com	temp2					;invert bits
	bst	temp2,0					;store bit to T
	bld	RegEther1bit0,TxMinusPin		;and store it to given register
	bld	RegEther0bit0,TxPlusPin
	bst	temp2,1					;store bit to T
	bld	RegEther1bit1,TxMinusPin		;and store it to given register
	bld	RegEther0bit1,TxPlusPin
	bst	temp2,2					;store bit to T
	bld	RegEther1bit2,TxMinusPin		;and store it to given register
	bld	RegEther0bit2,TxPlusPin
	bst	temp2,3					;store bit to T
	bld	RegEther1bit3,TxMinusPin		;and store it to given register
	bld	RegEther0bit3,TxPlusPin
	bst	temp2,4					;store bit to T
	bld	RegEther1bit4,TxMinusPin		;and store it to given register
	bld	RegEther0bit4,TxPlusPin
	bst	temp2,5					;store bit to T
	bld	RegEther1bit5,TxMinusPin		;and store it to given register
	bld	RegEther0bit5,TxPlusPin
	bst	temp2,6					;store bit to T
	bld	RegEther1bit6,TxMinusPin		;and store it to given register
	bld	RegEther0bit6,TxPlusPin
	bst	temp2,7					;store bit to T
	bld	RegEther1bit7,TxMinusPin		;and store it to given register
	bld	RegEther0bit7,TxPlusPin
        in      temp0, ETHDirection         ;load UDPport direction
        sbr     temp0, (1<<TxMinusPin)|(1<<TxPlusPin) ;enable transmiter pins
        out     ETHDirection, temp0         ;and write back to direction reg - start transmitting
;;;;;;;;;;;;;;;;;;;.ENDMACRO
sendpk_burststart:
        ;42+78 = 120ck = 6 usec pre-delay excl entry
        //82 bytes 8pre 4post= 1504 clock = 75.2 us
        #include "ethsend.inc"
        ;39 exit = 2 usec
;;;;;;;;;; .MACRO CloseUDPSend                             ;closes UDP sending
	out     ETHPort,temp1			;recover default state
sendpk_burstend:
//        in      r24,_SFR_IO_ADDR(TCNT1L) ;time stamp the end of the frame
//        in      r25,_SFR_IO_ADDR(TCNT1H)
        lds      r24,TCNT1L ;time stamp the end of the frame
        lds      r25,TCNT1H
        ;;;;; cbr     temp0, (1<<TxMinusPin)|(1<<TxPlusPin) ;disable transmiter pins
        ;;;;; out     EthDirection, temp0         ;and write back to direction reg - stop transmitting

	pop	RegEther1bit7		;restore all used registers (can be used in main program)
	pop	RegEther0bit7
	pop	RegEther1bit6
	pop	RegEther0bit6
	pop	RegEther1bit5
	pop	RegEther0bit5
	pop	RegEther1bit4
	pop	RegEther0bit4
	pop	RegEther1bit3
	pop	RegEther0bit3
	pop	RegEther1bit2
	pop	RegEther0bit2
	pop	RegEther1bit1
	pop	RegEther0bit1
	pop	RegEther1bit0
	pop	RegEther0bit0
	pop	RegEther1
	pop	RegEther0
	pop	temp2
	pop	temp1
	pop	temp0
        ret
;;;;;;;;;;;.ENDMACRO


;ohshit:
;        nop
;        nop
;        nop
;        rjmp ohshit
;
;ohshit3:
;        nop
;        nop
;        nop
;        rjmp ohshit3
 ;



.global sendpps
.global sendpps_precise


sendpps_precise:
//        in      r18,_SFR_IO_ADDR(TCNT1L)
//        in      r19,_SFR_IO_ADDR(TCNT1H)
        lds      r18,TCNT1L
        lds      r19,TCNT1H
        lds     r20,PreciseTxTime+0
        lds     r21,PreciseTxTime+1
        sub     r20,r18
        sbc     r21,r19
        brpl    sendpps_precise ;10 ck loop


;        cpi r21,0xff
;        brne ohshit
;        cpi r20,0xf6
;        brcs ohshit3

        //-1 .. -12
        ldi     r30,lo8(pm(wm2pt))
        ldi     r31,hi8(pm(wm2pt))
        sub     r30,r20
        sbc     r31,r21
wm2pt:  ijmp
        nop ;f  -1
        nop ;e
        nop ;d
        nop ;c
        nop ;b
        nop ;a
        nop ;9
        nop ;8
        nop ;7  -9
        nop ;6  -10
        nop ;5  -11
            ;4  -12
sendpps:
	push	temp0
	push	temp1
	push	temp2
	push	RegEther0
	push	RegEther1
	push	RegEther0bit0
	push	RegEther1bit0
	push	RegEther0bit1
	push	RegEther1bit1
	push	RegEther0bit2
	push	RegEther1bit2
	push	RegEther0bit3
	push	RegEther1bit3
	push	RegEther0bit4
	push	RegEther1bit4
	push	RegEther0bit5
	push	RegEther1bit5
	push	RegEther0bit6
	push	RegEther1bit6
	push	RegEther0bit7
	push	RegEther1bit7 ;21=42ck

        in      temp0, ETHPort                  ;load port state
        cbr     temp0, (1<<TxPlusPin)|(1<<TxMinusPin)          ;clear TX+ and TX-
	mov	temp1,temp0			;store the default state for recovering
	out     ETHPort,temp1			;back to port as default state - no voltage between TX pins

	sbr     temp0, (1<<TxMinusPin)          ;set TX- (TX+ was cleared)
        mov     RegEther0, temp0               ;and store as log0 state

        sbr     temp0, (1<<TxPlusPin)           ;set TX+
        cbr     temp0, (1<<TxMinusPin)          ;clear TX-
        mov     RegEther1, temp0               ;and store as log1 state

        mov temp2,r24
	mov	RegEther0bit0,RegEther0		;assign to UDPBit value
	mov	RegEther1bit0,RegEther1
	mov	RegEther0bit1,RegEther0		;assign to UDPBit value
	mov	RegEther1bit1,RegEther1
	mov	RegEther0bit2,RegEther0		;assign to UDPBit value
	mov	RegEther1bit2,RegEther1
	mov	RegEther0bit3,RegEther0		;assign to UDPBit value
        mov	RegEther1bit3,RegEther1
	mov	RegEther0bit4,RegEther0		;assign to UDPBit value
	mov	RegEther1bit4,RegEther1
	mov	RegEther0bit5,RegEther0		;assign to UDPBit value
	mov	RegEther1bit5,RegEther1
	mov	RegEther0bit6,RegEther0		;assign to UDPBit value
	mov	RegEther1bit6,RegEther1
	mov	RegEther0bit7,RegEther0		;assign to UDPBit value
	mov	RegEther1bit7,RegEther1
	bst	temp2,0					;store bit to T
	bld	RegEther0bit0,TxMinusPin		;and store it to given register
	bld	RegEther1bit0,TxPlusPin
	bst	temp2,1					;store bit to T
	bld	RegEther0bit1,TxMinusPin		;and store it to given register
	bld	RegEther1bit1,TxPlusPin
	bst	temp2,2					;store bit to T
	bld	RegEther0bit2,TxMinusPin		;and store it to given register
	bld	RegEther1bit2,TxPlusPin
	bst	temp2,3					;store bit to T
	bld	RegEther0bit3,TxMinusPin		;and store it to given register
	bld	RegEther1bit3,TxPlusPin
	bst	temp2,4					;store bit to T
	bld	RegEther0bit4,TxMinusPin		;and store it to given register
	bld	RegEther1bit4,TxPlusPin
	bst	temp2,5					;store bit to T
	bld	RegEther0bit5,TxMinusPin		;and store it to given register
	bld	RegEther1bit5,TxPlusPin
	bst	temp2,6					;store bit to T
	bld	RegEther0bit6,TxMinusPin		;and store it to given register
	bld	RegEther1bit6,TxPlusPin
	bst	temp2,7					;store bit to T
	bld	RegEther0bit7,TxMinusPin		;and store it to given register
	bld	RegEther1bit7,TxPlusPin
	;--------------------------------------------------------------
	com	temp2					;invert bits
	bst	temp2,0					;store bit to T
	bld	RegEther1bit0,TxMinusPin		;and store it to given register
	bld	RegEther0bit0,TxPlusPin
	bst	temp2,1					;store bit to T
	bld	RegEther1bit1,TxMinusPin		;and store it to given register
	bld	RegEther0bit1,TxPlusPin
	bst	temp2,2					;store bit to T
	bld	RegEther1bit2,TxMinusPin		;and store it to given register
	bld	RegEther0bit2,TxPlusPin
	bst	temp2,3					;store bit to T
	bld	RegEther1bit3,TxMinusPin		;and store it to given register
	bld	RegEther0bit3,TxPlusPin
	bst	temp2,4					;store bit to T
	bld	RegEther1bit4,TxMinusPin		;and store it to given register
	bld	RegEther0bit4,TxPlusPin
	bst	temp2,5					;store bit to T
	bld	RegEther1bit5,TxMinusPin		;and store it to given register
	bld	RegEther0bit5,TxPlusPin
	bst	temp2,6					;store bit to T
	bld	RegEther1bit6,TxMinusPin		;and store it to given register
	bld	RegEther0bit6,TxPlusPin
	bst	temp2,7					;store bit to T
	bld	RegEther1bit7,TxMinusPin		;and store it to given register
	bld	RegEther0bit7,TxPlusPin
        in      temp0, ETHDirection         ;load UDPport direction
        sbr     temp0, (1<<TxMinusPin)|(1<<TxPlusPin) ;enable transmiter pins
        out     ETHDirection, temp0         ;and write back to direction reg - start transmitting
;;;;;;;;;;;;;;;;;;;.ENDMACRO
sendpps_burststart:
        ;42+78 = 120ck = 6 usec pre-delay excl entry
        //82 bytes 8pre 4post= 1504 clock = 75.2 us
        #include "ethpps.inc"
        ;39 exit = 2 usec
;;;;;;;;;; .MACRO CloseUDPSend                             ;closes UDP sending
	out     ETHPort,temp1			;recover default state
sendpps_burstend:
//        in      r24,_SFR_IO_ADDR(TCNT1L) ;time stamp the end of the frame
//        in      r25,_SFR_IO_ADDR(TCNT1H)
        lds      r24,TCNT1L ;time stamp the end of the frame
        lds      r25,TCNT1H
        ;;;;; cbr     temp0, (1<<TxMinusPin)|(1<<TxPlusPin) ;disable transmiter pins
        ;;;;; out     UDPPortDirection, temp0         ;and write back to direction reg - stop transmitting

	pop	RegEther1bit7		;restore all used registers (can be used in main program)
	pop	RegEther0bit7
	pop	RegEther1bit6
	pop	RegEther0bit6
	pop	RegEther1bit5
	pop	RegEther0bit5
	pop	RegEther1bit4
	pop	RegEther0bit4
	pop	RegEther1bit3
	pop	RegEther0bit3
	pop	RegEther1bit2
	pop	RegEther0bit2
	pop	RegEther1bit1
	pop	RegEther0bit1
	pop	RegEther1bit0
	pop	RegEther0bit0
	pop	RegEther1
	pop	RegEther0
	pop	temp2
	pop	temp1
	pop	temp0
        ret
;;;;;;;;;;;.ENDMACRO

